# awesome-java-leetcode

我如今是一名 Android Developer，大学的我曾是一名 ACMer，我一直认为数据结构和算法是作为一名程序员必须掌握和善于利用的，为了不让数据结构和算法淡出我的记忆，所以我打算重拾 LeetCode 之 Algorithm，语言选择的是 Java，题库会一点点完善起来，按简单，中等，困难分类，相应难度下按题号排序，源代码在 [src][src] 目录中，相关解题都在 [note][note] 目录中，想要学习数据结构和算法或打算刷 LeetCode 的小伙伴们欢迎 star 哦。

如今有机会面试 Facebook，附上 LeetCode 上 Facebook 的面试题目序号，希望可以帮助到以后想入 Facebook 的小伙伴:-)

```
1,10,13,15,17,20,23,25,26,28,33,38,43,44,49,50,56,57,67,68,69,71,75,76
78,79,80,85,88,90,91,98,102,117,121,125,127,128,133,139,146,157,158,161
168,173,200,206,208,209,210,211,215,218,221,234,235,236,238,252,253,257
261,265,269,273,274,275,277,278,282,283,285,286,297,301,311,314,325,334
341,377,380,398,404,410,461,477,494,523,525,534,535,543,554
```

如果想知道更多公司 LeetCode 面试题，可以参看 [Companies.md][companies]。

附上镇楼诗：

> 明有科举八股，今有 LeetCode。  
> 八股定格式而取文采心意，LeetCode 定题目且重答案背诵。  
> 美其名曰："practice makes perfect."  
> 为何今不如古？  
> 非也非也，  
> 科举为国取士，LeetCode 为 Google 筛码工，各取所需也。  


## Easy

| #    | Title                                    | Tag                                      |
| :--- | :--------------------------------------- | :--------------------------------------- |
| 1    | [Two Sum][001]                           | Array, Hash Table                        |
| 7    | [Reverse Integer][007]                   | Math                                     |
| 9    | [Palindrome Number][009]                 | Math                                     |
| 13   | [Roman to Integer][013]                  | Math, String                             |
| 14   | [Longest Common Prefix][014]             | String                                   |
| 20   | [Valid Parentheses][020]                 | Stack, String                            |
| 21   | [Merge Two Sorted Lists][021]            | Linked List                              |
| 26   | [Remove Duplicates from Sorted Array][026] | Array, Two Pointers                      |
| 27   | [Remove Element][027]                    | Array, Two Pointers                      |
| 28   | [Implement strStr()][028]                | Two Pointers, String                     |
| 35   | [Search Insert Position][035]            | String                                   |
| 38   | [Count and Say][038]                     | String                                   |
| 53   | [Maximum Subarray][053]                  | Array, Divide and Conquer, Dynamic Programming |
| 58   | [Length of Last Word][058]               | String                                   |
| 66   | [Plus One][066]                          | Array, Math                              |
| 67   | [Add Binary][067]                        | Math, String                             |
| 69   | [Sqrt(x)][069]                           | Binary Search, Math                      |
| 70   | [Climbing Stairs][070]                   | Dynamic Programming                      |
| 83   | [Remove Duplicates from Sorted List][083] | Linked List                              |
| 88   | [Merge Sorted Array][088]                | Array, Two Pointers                      |
| 100  | [Same Tree][100]                         | Tree, Depth-first Search                 |
| 101  | [Symmetric Tree][101]                    | Tree, Depth-first Search, Breadth-first Search |
| 104  | [Maximum Depth of Binary Tree][104]      | Tree, Depth-first Search                 |
| 107  | [Binary Tree Level Order Traversal II][107] | Tree, Breadth-first Search               |
| 108  | [Convert Sorted Array to Binary Search Tree][108] | Tree, Depth-first Search                 |
| 110  | [Balanced Binary Tree][110]              | Tree, Depth-first Search                 |
| 111  | [Minimum Depth of Binary Tree][111]      | Tree, Depth-first Search, Breadth-first Search |
| 112  | [Path Sum][112]                          | Tree, Depth-first Search                 |
| 118  | [Pascal's Triangle][118]                 | Array                                    |
| 119  | [Pascal's Triangle II][119]              | Array                                    |
| 121  | [Best Time to Buy and Sell Stock][121]   | Array, Dynamic Programmin                |
| 122  | [Best Time to Buy and Sell Stock II][122] | Array, Greedy                            |
| 543  | [Diameter of Binary Tree][543]           | Tree                                     |


## Medium

| #    | Title                                    | Tag                              |
| :--- | :--------------------------------------- | :------------------------------- |
| 2    | [Add Two Numbers][002]                   | Linked List, Math                |
| 3    | [Longest Substring Without Repeating Characters][003] | Hash Table, Two Pointers, String |
| 5    | [Longest Palindromic Substring][005]     | String, Dynamic Programming      |
| 6    | [ZigZag Conversion][006]                 | String                           |
| 8    | [String to Integer (atoi)][008]          | Math, String                     |
| 11   | [Container With Most Water][011]         | Array, Two Pointers              |
| 12   | [Integer to Roman][012]                  | Math, String                     |
| 15   | [3Sum][015]                              | Array, Two Pointers              |
| 15   | [3Sum Closest][016]                      | Array, Two Pointers              |
| 17   | [Letter Combinations of a Phone Number][017] | String, Backtracking             |
| 18   | [4Sum][018]                              | Array, Hash Table, Two Pointers  |
| 19   | [Remove Nth Node From End of List][019]  | Linked List, Two Pointers        |
| 22   | [Generate Parentheses][022]              | String, Backtracking             |
| 24   | [Swap Nodes in Pairs][024]               | Linked List                      |
| 29   | [Divide Two Integers][029]               | Math, Binary Search              |
| 33   | [Search in Rotated Sorted Array][033]    | Arrays, Binary Search            |
| 43   | [Multiply Strings][043]                  | Math, String                     |
| 49   | [Group Anagrams][049]                    | Hash Table, String               |
| 50   | [Pow(x, n)][050]                         | Math, Binary Search              |
| 56   | [Merge Intervals][056]                   | Array, Sort                      |
| 554  | [Brick Wall][554]                        | Hash Table                       |


## Hard

| #    | Title                                    | Tag                                      |
| :--- | :--------------------------------------- | :--------------------------------------- |
| 4    | [Median of Two Sorted Arrays][004]       | Array, Binary Search, Divide and Conquer |
| 10   | [Regular Expression Matching][010]       | String, Dynamic Programming, Backtracking |
| 23   | [Merge k Sorted Lists][023]              | Linked List, Divide and Conquer, Heap    |
| 25   | [Reverse Nodes in k-Group][025]          | Linked List                              |
| 30   | [Substring with Concatenation of All Words][030] | Hash Table, Two Pointers, String         |
| 44   | [Wildcard Matching][044]                 | String, Dynamic Programming, Backtracking, Greedy |
| 57   | [Insert Interval][057]                   | Array, Sort                              |
| 68   | [Text Justification][068]                | String                                   |


## 打个小广告

欢迎加入我的知识星球「**[基你太美](https://t.zsxq.com/FmeqfYF)**」，我会在星球中分享 [AucFrame](https://blankj.com/2019/07/22/auc-frame/) 框架、大厂面经、[AndroidUtilCode](https://github.com/Blankj/AndroidUtilCode) 更详尽的说明...一切我所了解的知识，你可以通过支付进入我的星球「**[基你太美](https://t.zsxq.com/FmeqfYF)**」进行体验，加入后优先观看星球中精华的部分，如果觉得星球的内容对自身没有收益，你可以自行申请退款退出星球，也没必要加我好友；**如果你已确定要留在我的星球，可以通过扫描如下二维码（备注：基你太美）加我个人微信，发送给我你的星球 ID，方便我后续拉你进群(PS：进得越早价格越便宜)。**

![我的二维码](https://raw.githubusercontent.com/Blankj/AndroidUtilCode/master/art/wechat.png)


[src]: https://github.com/Blankj/awesome-java-leetcode/tree/master/src
[note]: https://github.com/Blankj/awesome-java-leetcode/tree/master/note
[companies]: https://github.com/Blankj/awesome-java-leetcode/blob/master/Companies.md

[001]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/001/README.md
[007]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/007/README.md
[009]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/009/README.md
[013]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/013/README.md
[014]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/014/README.md
[020]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/020/README.md
[021]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/021/README.md
[026]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/026/README.md
[027]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/027/README.md
[028]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/028/README.md
[035]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/035/README.md
[038]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/038/README.md
[053]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/053/README.md
[058]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/058/README.md
[066]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/066/README.md
[067]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/067/README.md
[069]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/069/README.md
[070]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/070/README.md
[083]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/083/README.md
[088]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/088/README.md
[100]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/100/README.md
[101]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/101/README.md
[104]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/104/README.md
[107]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/107/README.md
[108]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/108/README.md
[110]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/110/README.md
[111]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/111/README.md
[112]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/112/README.md
[118]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/118/README.md
[119]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/119/README.md
[121]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/121/README.md
[122]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/122/README.md
[543]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/543/README.md

[002]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/002/README.md
[003]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/003/README.md
[005]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/005/README.md
[006]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/006/README.md
[008]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/008/README.md
[011]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/011/README.md
[012]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/012/README.md
[015]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/015/README.md
[016]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/016/README.md
[017]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/017/README.md
[018]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/018/README.md
[019]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/019/README.md
[022]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/022/README.md
[024]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/024/README.md
[029]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/029/README.md
[033]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/033/README.md
[043]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/043/README.md
[049]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/049/README.md
[050]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/050/README.md
[056]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/056/README.md
[554]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/554/README.md

[004]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/004/README.md
[010]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/010/README.md
[023]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/023/README.md
[025]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/025/README.md
[030]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/030/README.md
[044]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/044/README.md
[057]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/057/README.md
[068]: https://github.com/Blankj/awesome-java-leetcode/blob/master/note/068/README.md
